local MAJOR = "LibScriptableDisplayCoreLite-1.0" 
local MINOR = 15

local LibCore = LibStub:NewLibrary(MAJOR, MINOR)
if not LibCore then return end
local LibTimer = LibStub("LibScriptableDisplayTimer-1.0", true)
assert(LibTimer, MAJOR .. " requires LibScriptableDisplayTimer-1.0")
local LibError = LibStub("LibScriptableDisplayError-1.0", true)
assert(LibError, MAJOR .. " requires LibScriptableDisplayError-1.0")
local LibCFG = LibStub("LibScriptableDisplayCFG-1.0", true)
assert(LibCFG, MAJOR .. " requires LibScriptableDisplayCFG-1.0")

local WidgetText = LibStub("LibScriptableDisplayWidgetText-1.0", true)
assert(WidgetText, MAJOR .. " requires LibScriptableDisplayWidgetText-1.0")
local WidgetBar = LibStub("LibScriptableDisplayWidgetBar-1.0", true)
assert(WidgetBar, MAJOR .. " requires LibScriptableDisplayWidgetBar-1.0")
local WidgetIcon = LibStub("LibScriptableDisplayWidgetIcon-1.0", true)
assert(WidgetIcon, MAJOR .. " requires LibScriptableDisplayWidgetIcon-1.0")
local WidgetHistogram = LibStub("LibScriptableDisplayWidgetHistogram-1.0", true)
assert(WidgetHistogram, MAJOR .. " requires LibScriptableDisplayWidgetHistogram-1.0")
local WidgetBignums = LibStub("LibScriptableDisplayWidgetBignums-1.0", true)
--assert(WidgetBignums, MAJOR .. " requires LibScriptableDisplayWidgetBignums-1.0")
local WidgetKey = LibStub("LibScriptableDisplayWidgetKey-1.0", true)
assert(WidgetKey, MAJOR .. " requires LibScriptableDisplayWidgetKey-1.0")
local WidgetTimer = LibStub("LibScriptableDisplayWidgetTimer-1.0", true)
assert(WidgetTimer, MAJOR .. " requires LibScriptableDisplayWidgetTimer-1.0")
local WidgetGestures = LibStub("LibScriptableDisplayWidgetGestures-1.0")
assert(WidgetGestures, MAJOR .. "LibScriptableDisplayWidgetGestures-1.0")

local Evaluator = LibStub("LibScriptableDisplayEvaluator-1.0", true)
assert(Evaluator, MAJOR .. " requires LibScriptableDisplayEvaluator-1.0")

local PluginRangeCheck = LibStub("LibScriptableDisplayPluginRangeCheck-1.0", true)
assert(PluginRangeCheck, MAJOR .. " requires LibScriptableDisplayRangeCheck-1.0")
local PluginUnit = LibStub("LibScriptableDisplayPluginUnit-1.0", true)
assert(PluginUnit, MAJOR .. " requires LibScriptableDisplayPluginUnit-1.0")
local PluginBit = LibStub("LibScriptableDisplayPluginBit-1.0", true)
assert(PluginBit, MAJOR .. " requires LibScriptableDisplayPluginBit-1.0")
local PluginLua = LibStub("LibScriptableDisplayPluginLua-1.0", true)
assert(PluginLua, MAJOR .. " requires LibScriptableDisplayPluginLua-1.0")
local PluginMath = LibStub("LibScriptableDisplayPluginMath-1.0", true)
assert(PluginMath, MAJOR .. " requires LibScriptableDisplayPluginMath-1.0")
local PluginString = LibStub("LibScriptableDisplayPluginString-1.0", true)
assert(PluginString, MAJOR .. " requires LibScriptableDisplayPluginString-1.0")
local PluginTable = LibStub("LibScriptableDisplayPluginTable-1.0", true)
assert(PluginTable, MAJOR .. " requires LibScriptableDisplayPluginTable-1.0")
local PluginResourceTools = LibStub("LibScriptableDisplayPluginResourceTools-1.0", true)
assert(PluginResourceTools, MAJOR .. " requires LibScriptableDisplayPluginResourceTools-1.0")
local PluginCharacterStats = LibStub("LibScriptableDisplayPluginCharacterStats-1.0", true)
assert(PluginCharacterStats, MAJOR .. " requires LibScriptableDisplayPluginCharacterStats-1.0")
local PluginLocation = LibStub("LibScriptableDisplayPluginLocation-1.0", true)
assert(PluginLocation, MAJOR .. " requires LibScriptableDisplayPluginLocation-1.0")
local PluginUnitTooltipStats = LibStub("LibScriptableDisplayPluginUnitTooltipStats-1.0", true)
assert(PluginUnitTooltipStats, MAJOR .. " requires LibScriptableDisplayPluginUnitTooltipStats-1.0")
local PluginDBM = LibStub("LibScriptableDisplayPluginDBM-1.0", true) -- no assertion needed.
local PluginLinq = LibStub("LibScriptableDisplayPluginLinq-1.0", true)
assert(PluginLinq, MAJOR .. " requires LibScriptableDisplayPluginLinq-1.0")
local PluginGuild = LibStub("LibScriptableDisplayPluginGuild-1.0", true)
assert(PluginGuild, MAJOR .. " requires LibScriptableDisplayPluginGuild-1.0")
local PluginSpell = LibStub("LibScriptableDisplayPluginSpell-1.0", true)
assert(PluginSpell, MAJOR .. " requires LibScriptableDisplayPluginSpell-1.0")
local PluginComm = LibStub("LibScriptableDisplayPluginComm-1.0", true)
assert(PluginComm, MAJOR .. " requires LibScriptableDisplayPluginComm-1.0")
local PluginSerializer = LibStub("LibScriptableDisplayPluginSerializer-1.0", true)
assert(PluginSerializer, MAJOR .. " requires LibScriptableDisplayPluginSerializer-1.0")
local PluginColor = LibStub("LibScriptableDisplayPluginColor-1.0", true)
assert(PluginColor, MAJOR .. " requires LibScriptableDisplayPluginColor-1.0")
local PluginLuaTexts = LibStub("LibScriptableDisplayPluginLuaTexts-1.0", true)
assert(PluginLuaTexts, MAJOR .. " requires LibScriptableDisplayPluginLuaTexts-1.0")
local PluginTalents = LibStub("LibScriptableDisplayPluginTalents-1.0", true)
assert(PluginTalents, MAJOR .. " requires LibScriptableDisplayPluginTalents-1.0")
local PluginUtils = LibStub("LibScriptableDisplayPluginUtils-1.0", true)
assert(PluginUtils, MAJOR .. " requires LibScriptableDisplayPluginUtils-1.0")
local PluginUnitControl = LibStub("LibScriptableDisplayPluginUnitControl-1.0", true)
assert(PluginUnitControl, MAJOR .. " requires LibScriptableDisplayPluginUnitControl-1.0")
local PluginFail = LibStub("LibScriptableDisplayPluginFail-1.0")
assert(PluginFail, MAJOR .. " requires LibScriptableDisplayPluginFail-1.0")
local PluginBlend = LibStub("LibScriptableDisplayPluginBlend-1.0")
assert(PluginBlend, MAJOR .. " requires LibScriptableDisplayPluginBlend-1.0")
local PluginNameplate = LibStub("LibScriptableDisplayPluginNameplate-1.0")
assert(PluginNameplate, MAJOR .. " requires LibScriptableDisplayPluginNameplate-1.0")


local pool = setmetatable({}, {__mode = "k"})
local objects = {}
local objectDicts = {}

if not LibCore.__index then
	LibCore.__index = LibCore
	LibCore.driverList = {}
	LibCore.driverDict = {}
end

LibCore.TRANSITION_RIGHT = 0
LibCore.TRANSITION_LEFT = 1
LibCore.TRANSITION_BOTH = 2
LibCore.TRANSITION_UP = 3
LibCore.TRANSITION_DOWN = 4
LibCore.TRANSITION_TENTACLE = 5
LibCore.TRANSITION_ALPHABLEND = 6
LibCore.TRANSITION_CHECKERBOARD = 7

local defaults = {rows = 4, cols = 20, transition_timeout = 10000, transition_speed = 100, timeout = 500}

LibCore.defaults = defaults

-- @name LibScriptableDisplayCore:New
-- @description Note that you must provide the object an lcd object: core.lcd = myTextLCD
-- @usage LibScriptableDisplayCore:New(visitor, environment, name, config, typeOf, lcd, errorLevel)
-- @parma visitor App table
-- @return A new LibScriptableDisplayCore object
function LibCore:New(environment, name, errorLevel)
	
	local obj = next(pool)

	if obj then
		pool[obj] = nil
	else
		obj = {}
	end

	if type(config) == "string" then
		config = Evaluator.ExecuteCode(environment, "LibCore:New", config)
	end

	setmetatable(obj, self)
	
	tinsert(objects, obj)
		
	obj.visitor = visitor
	obj.environment = environment
	obj.error = LibError:New(MAJOR, errorLevel)
	obj.errorLevel = errorLevel
	
	environment.visitor = obj
	
	-- Plugins
	PluginRangeCheck:New(environment)
	PluginUnit:New(environment)
	PluginBit:New(environment)
	PluginLua:New(environment)
	PluginMath:New(environment)
	PluginString:New(environment)
	PluginTable:New(environment)
	PluginResourceTools:New(environment)
	PluginLocation:New(environment)
	PluginUnitTooltipStats:New(environment)
	if PluginDBM then PluginDBM:New(environment) end
	PluginLinq:New(environment)
	PluginGuild:New(environment)
	PluginSpell:New(environment)
	PluginComm:New(environment)
	PluginSerializer:New(environment)
	PluginColor:New(environment)
	PluginLuaTexts:New(environment)
	PluginTalents:New(environment)
	PluginUtils:New(environment)
	PluginUnitControl:New(environment)
	PluginFail:New(environment)
	PluginBlend:New(environment)
	PluginNameplate:New(environment)
	
	environment._G = _G
	environment.environment = environment

	environment.WidgetText = WidgetText
	environment.WidgetBar = WidgetBar
	environment.WidgetIcon = WidgetIcon
	environment.WidgetHistogram = WidgetHistogram
	environment.WidgetBignums = WidgetBignums
	environment.WidgetKey = WidgetKey
	environment.WidgetTimer = WidgetTimer
	environment.WidgetScript = WidgetScript
	environment.WidgetGestures = WidgetGestures
	environment.WidgetImage = WidgetImage
				
	return obj	
	
end

-- @name LibScriptableDisplayCore:Del
-- @usage LibScriptableDisplayCore:Del([core]) or object:Del()
-- @param core An optional core object
-- @return Nothing
function LibCore:Del(core)
	if not core then core = self end
	
	for i, v in ipairs(objects) do
		if v == self then
			tremove(objects, i)
		end
	end
	
	pool[core] = true
	
	for i, v in ipairs(core.widgets) do
		v:Del()
	end
	
	core.error:Del()
end

function LibCore:RegisterDriver(driver)
	tinsert(LibCore.driverList, driver)
	LibCore.driverDict[driver] = #LibCore.driverList
end

function LibCore:RebuildOpts(visitor, db)
	local options = {
--[[		name = {
			name = "Name",
			desc = "This display's name",
			type = "input",
			get = function() return db.name end,
			set = function(info, v)
				db.name = v
			end,
			order = 10
		},]]
		rows = {
			name = "Rows",
			desc = "This display's rows",
			type = "input",
			pattern = "%d",
			get = function() return tostring(db.rows or defaults.rows) end,
			set = function(info, v) db.rows = tonumber(v) end,
			order = 12
		},
		cols = {
			name = "Columns",
			desc = "This display's columns",
			type = "input",
			pattern = "%d",
			get = function() return tostring(db.cols or defaults.cols) end,
			set = function(info, v) db.cols = tonumber(v) end,
			order = 13
		},
		update = {
			name = "Update",
			desc = "This display's refresh rate",
			type = "input",
			pattern = "%d",
			get = function() return tostring(db.update or defaults.update) end,
			set = function(info, v) db.update = tonumber(v) end,
			order = 14
		},
		transition_timeout = {
			name = "Transition Timeout",
			desc = "This display's transition timeout",
			type = "input",
			pattern = "%d",
			get = function() return tostring(db.transition_timeout or defaults.transition_timeout) end,
			set = function(info, v) db.transition_timeout = tonumber(v) end,
			order = 16
		},
		transition_speed = {
			name = "Transition Speed",
			desc = "This display's transition speed",
			type = "input",
			pattern = "%d",
			get = function() return tostring(db.transition_speed or defaults.transition_speed) end,
			set = function(info, v) db.transition_speed = tonumber(v) end,
			order = 17
		},
		widgets = {
			name = "Widgets",
			type = "group",
			args = {
				add = {
					name = "Add a widget",
					desc = "Add a widget",
					type = "input",
					set = function(info, v)
						tinsert(db.widgets, "widget_" .. v)
						visitor:RebuildOpts(true)
					end,
					order = 1
				}
			},
			order = 18,
		},
		layouts = {
			name = "Layouts",
			type = "group",
			args = {
				add = {
					name = "Add a layout",
					desc = "Add a layout",
					type = "input",
					set = function(info, v)
						tinsert(db.layouts, "layout_" .. v)
						visitor:RebuildOpts(true)
					end,
					order = 1
				},
			},
			order = 19
		}
	}
	
	for i, v in ipairs(db.widgets or {}) do
		if v.type == "text" then
			options.widgets.args["widget" .. i] = {
				name = "Widget " .. i,
				type = "group",
				args = {
					name = {
						name = v,
						type = "input",
						get = function() return v end,
						set = function(info, v) 
							db.widgets[i] = v 
							visitor:RebuildOpts(true)
						end,
						order = 1
					},
					remove = {
						name = "Remove",
						type = "execute",
						func = function()
							tremove(db.widgets, i)
							visitor:RebuildOpts(true)
						end,
						order = 2
					}
				}
			}
		end
	end
	
	for i, v in ipairs(db.layouts) do
		options.layouts.args["layout" .. i] = {
			name = "Layout " .. i,
			type = "group",
			args = {
				name = {
					name = v,
					type = "input",
					get = function() return v end,
					set = function(info, v) 
						db.layouts[i] = v 
					end,
					order = 1
				},
				up = {
					name = "Up",
					desc = "Move this layout up in the list",
					type = "execute",
					func = function()
						if i == 1 then return end
						db.layouts[i] = db.layouts[i - 1]
						db.layouts[i - 1] = v
						visitor:RebuildOpts(true)
					end,
					order = 2
				},
				down = {
					name = "Down",
					desc = "Move this layout down in the list",
					type = "execute",
					func = function()
						if i == #db.layouts then return end
						db.layouts[i] = db.layouts[i + 1]
						db.layouts[i + 1] = v
						visitor:RebuildOpts(true)
					end,
					order = 3
				},
				remove = {
					name = "Remove",
					desc = "Remove this layout from the display's list",
					type = "execute",
					func = function()
						tremove(db.layouts, i)
						visitor:RebuildOpts()
					end,
					order = 4
				}
			}
		}
	end
	return options
end


